#include "stdafx.h"

bool split(char *buf, char *comp, char *cmd)
{   int Beg = -1, End = -1;
    int k;
	unsigned int i;
	 
	//   [
    for (i=0; i<strlen(buf); i++)
		if (buf[i]=='[') { Beg=i; break; }
    if (Beg<0) return false;

    for (i=0; i<strlen(buf); i++)
		if (buf[i]==']') { End=i; break; }
    if (End<Beg) return false;

	k=0;
	for (i=Beg; i<=End; i++) comp[k++]=buf[i]; 
	comp[k]='\0';

	k=0;
	for (i=End+2; i<=strlen(buf); i++) cmd[k++]=buf[i];

	return true;
}

int main()
{
    const char * name = "\\\\.\\mailslot\\main";
	const int MessageSize = 4096;
	HANDLE hSlot;    //   
	HANDLE hCRT;     //  
	DWORD ms;        //   
	DWORD cb;		 //   
	DWORD retCode;
	CHAR  Buff[MessageSize];
	CHAR  Cmd[MessageSize];
	CHAR  Comp[128];

	hCRT=GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleTextAttribute(hCRT,FOREGROUND_GREEN | FOREGROUND_INTENSITY);

	hSlot=CreateMailslot(name,MessageSize,MAILSLOT_WAIT_FOREVER,NULL);

	if (hSlot==INVALID_HANDLE_VALUE)
	{
		SetConsoleTextAttribute(hCRT,FOREGROUND_RED | FOREGROUND_INTENSITY);	
		printf("Cannot create mailslot %s\n",name);
		return -1;
	}
	else
		printf("Mail slot %s successfully created.\n",name);

	while (true)
	{
		retCode=GetMailslotInfo(hSlot,&ms,NULL,NULL,NULL);
		if (!retCode)
		{
		   SetConsoleTextAttribute(hCRT,FOREGROUND_RED | FOREGROUND_INTENSITY);	
		   printf("Error in mail slot %s\n",name);
		   return -2;
		}

		if (ms) //  
		{
		  ReadFile(hSlot,Buff,MessageSize-1,&cb,NULL);

		  if (split(Buff,Comp,Cmd))
		  {
			 SetConsoleTextAttribute(hCRT,FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_INTENSITY);	
		     printf("%s",Comp);
			 SetConsoleTextAttribute(hCRT, FOREGROUND_GREEN | FOREGROUND_INTENSITY);	
		     printf(" %s\n",Cmd);

			 if (Cmd[0]=='#')
			 {
				 if (WinExec(Cmd+1,SW_NORMAL)>31)
				 {	 SetConsoleTextAttribute(hCRT, FOREGROUND_BLUE | FOREGROUND_GREEN | FOREGROUND_INTENSITY);	
					 printf("Successfully executed.\n");
				 }
				 else
				 {	 SetConsoleTextAttribute(hCRT, FOREGROUND_RED | FOREGROUND_INTENSITY);	
					 printf("Error in a command.\n");
				 }
			 }

		  }
		}

		if (strcmp(Cmd,"exit")==0) break;

	} // end of while

	CloseHandle(hSlot);

    SetConsoleTextAttribute(hCRT, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_INTENSITY);	
	printf("Service stopped!\n",cb);


	return 0;
}

